<?php
function wordForm($num, $word) {
	$cases = array(2, 0, 1, 1, 1, 2);
	return $word[ ($num%100 > 4 && $num %100 < 20) ? 2 : $cases[min($num%10, 5)] ];  
}

$doc = JFactory::getDocument();
$doc->addStyleSheet('modules/mod_time_difference/asset/css/style.css');

$date_start = new DateTime($params->get('date_start'));
$date_now = new DateTime(date('Y-m-d h:i:s'));
$parts = $params->get('display_parts');

if ($params->get('animate_secondes') && in_array('secundes', $parts)) {
	if ($params->get('type_timer') == 'ASC' || ($params->get('type_timer') == 'DESC' && $date_now < $date_start)) {
		$doc->addScript('modules/mod_time_difference/asset/js/script.js');
	}
}

$interval = $date_now->diff($date_start);

$year = str_pad($interval->format('%y'), 2, '0', STR_PAD_LEFT);
$month = str_pad($interval->format('%m'), 2, '0', STR_PAD_LEFT);
$day = str_pad($interval->format('%d'), 2, '0', STR_PAD_LEFT);
$hour = str_pad($interval->format('%h'), 2, '0', STR_PAD_LEFT);
$minute = str_pad($interval->format('%i'), 2, '0', STR_PAD_LEFT);
$secunde = str_pad($interval->format('%s'), 2, '0', STR_PAD_LEFT);

if ($params->get('sum_parts')) {
	if (!in_array('years', $parts)) {
		$month = str_pad($month + ($year * 12), 2, '0', STR_PAD_LEFT);
		if (!in_array('months', $parts)) {
			$day = str_pad($interval->format('%a'), 2, '0', STR_PAD_LEFT);
			if (!in_array('days', $parts)) {
				$hour = str_pad($hour + ($day * 24), 2, '0', STR_PAD_LEFT);
				if (!in_array('hours', $parts)) {
					$minute = str_pad($minute + ($hour * 60), 2, '0', STR_PAD_LEFT);
					if (!in_array('minutes', $parts)) {
						$secunde = str_pad($secunde + ($minute * 60), 2, '0', STR_PAD_LEFT);
					}
				}
			}
		}
	}
}

//$total_secundes = $interval->format('%a') * 24 * 60 * 60 + $interval->format('%h') * 60 * 60 + $interval->format('%i') * 60 + $interval->format('%s');
//echo $total_secundes;

if ($params->get('type_timer') == 'DESC' && $date_now > $date_start) {
	$year = '00';
	$month = '00';
	$day = '00';
	$hour = '00';
	$minute = '00';
	$secunde = '00';
}
?>

<div class="time_difference <?php echo $params->get('moduleclass_sfx'); ?> <?php echo 'style' . $params->get('type_style'); ?> <?php echo $params->get('type_contrast'); ?>">
	<?php if ($params->get('text_top') != '') { ?>
		<div class="description block-top"><?php echo $params->get('text_top'); ?></div>
	<?php } ?>
	
	<div class="time_difference_timer <?php
		if ($params->get('type_timer') == 'DESC') {
			echo ' desc';
			if ($params->get('hide_timer')) {
				echo ' hide_timer';
				if ($date_now > $date_start) {
					echo ' timer_finish';
				}
			}
		}
	?>">
		<?php if (in_array('years', $parts)) { ?>
			<div class="time_difference_year time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($year); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $year[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $year[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo ($year[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo ($year[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($year, array(JText::_('MOD_TIME_DIFFERENCE_INFO_YEAR'), JText::_('MOD_TIME_DIFFERENCE_INFO_YEARS'), JText::_('MOD_TIME_DIFFERENCE_INFO_YEARS_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
		
		<?php if (in_array('months', $parts)) { ?>
			<div class="time_difference_month time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($month); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $month[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $month[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo ($month[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo ($month[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($month, array(JText::_('MOD_TIME_DIFFERENCE_INFO_MONTH'), JText::_('MOD_TIME_DIFFERENCE_INFO_MONTHS'), JText::_('MOD_TIME_DIFFERENCE_INFO_MONTHS_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
		
		<?php if (in_array('days', $parts)) { ?>
			<div class="time_difference_day time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($day); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $day[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $day[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo ($day[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo ($day[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($day, array(JText::_('MOD_TIME_DIFFERENCE_INFO_DAY'), JText::_('MOD_TIME_DIFFERENCE_INFO_DAYS'), JText::_('MOD_TIME_DIFFERENCE_INFO_DAYS_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
		
		<?php if (in_array('hours', $parts)) { ?>
			<div class="time_difference_hour time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($hour); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $hour[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $hour[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo ($hour[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo ($hour[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($hour, array(JText::_('MOD_TIME_DIFFERENCE_INFO_HOUR'), JText::_('MOD_TIME_DIFFERENCE_INFO_HOURS'), JText::_('MOD_TIME_DIFFERENCE_INFO_HOURS_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
		
		<?php if (in_array('minutes', $parts)) { ?>
			<div class="time_difference_minute time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($minute); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $minute[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $minute[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo ($minute[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo ($minute[$i] + 1); ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($minute, array(JText::_('MOD_TIME_DIFFERENCE_INFO_MINUTE'), JText::_('MOD_TIME_DIFFERENCE_INFO_MINUTES'), JText::_('MOD_TIME_DIFFERENCE_INFO_MINUTES_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
		
		<?php if (in_array('secundes', $parts)) { ?>
			<div class="time_difference_secunde time_param" style="<?php
				if ($params->get('type_direction') == 'vertical') {
					echo ' display: block;';
				}
			?>">
				<?php for ($i = 0; $i < strlen($secunde); $i++) { ?>
					<div class="one_value">
						<div class="one_value_inner part_current">
							<span class="value"><?php echo $secunde[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_bottom">
							<span class="value"><?php echo $secunde[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_next">
							<span class="value"><?php echo $secunde[$i]; ?></span>
							<span class="background"></span>
						</div>
						<div class="one_value_inner part_top">
							<span class="value"><?php echo $secunde[$i]; ?></span>
							<span class="background"></span>
						</div>
					</div>
				<?php } ?>
				<?php if ($params->get('parts_desc')) { ?>
					<span class="time_param_title"><?php echo wordForm($secunde, array(JText::_('MOD_TIME_DIFFERENCE_INFO_SECUNDE'), JText::_('MOD_TIME_DIFFERENCE_INFO_SECUNDES'), JText::_('MOD_TIME_DIFFERENCE_INFO_SECUNDES_MORE'))); ?></span>
				<?php } ?>
			</div>
		<?php } ?>
	</div>
	
	<?php if ($params->get('type_timer') == 'DESC' && $params->get('text_finish') != '') { ?>
		<div class="description block-finish<?php
			if ($params->get('hide_timer') && $date_now > $date_start) {
				echo ' timer_finish';
			}
		?>"><?php echo $params->get('text_finish'); ?></div>
	<?php } ?>
	
	<?php if ($params->get('text_bottom') != '') { ?>
		<div class="description block-bottom"><?php echo $params->get('text_bottom'); ?></div>
	<?php } ?>
</div>